/*
 * HD44780.asm
 *
 *  Created: 17.03.2013 9:07:14
 *   Author: sad
 */ 
  
 .def	temp=r16    ;  .def   r16  temp
 .def	temp1=r17
 .def	temp2=r18
 .def	temp3=r19
 .def	temp4=r20
 .def	temp5=r21
 .def	temp6=r22
 .def	temp7=r23
 .def	temp8=r24
 .def	Tx_b=r25
 
.equ	t1 = 180
.equ	t2 = 50
.equ	t3 = 250

.equ	E = 0		;    
.equ	RS = 1		; 
.equ	DB7 = 7		;   ,   DB7 
.equ	DB6 = 6
.equ	DB5 = 5
.equ	DB4 = 4

.dseg
.org	0x60
flags:	.byte 1
Adress:	.byte 1	; LSB
Adress1:	.byte 1	; MSB
BCD_DT:	.byte 1		; . 
BCD_T:	.byte 1		; 
BCD_S:	.byte 1		;  
BCD_D:	.byte 1		; 
BCD_E:	.byte 1		; 
Temps:	.byte 8		;    
Tim:	.byte 1		;  


;====================================================
;  
.cseg            ;  .cseg   ,   
                    ;   .  AVR Studio 5   
                    ; 
.org 0            ;    
 rjmp Start       ;     Start ( PIC  
                   ;  goto)
rjmp INT_0
rjmp INT_1
rjmp Timer1_capt1
rjmp Timer1_comp1
rjmp Timer1_OVF1
rjmp Timer0_OVF0
rjmp UART_RX
rjmp UART_UDRE
rjmp UART_TX
rjmp ANA_COMP

;Start: ;  
INT_0:
INT_1:
Timer1_capt1:
;Timer1_comp1: ;
Timer1_OVF1:
Timer0_OVF0:
UART_UDRE:
UART_TX:
UART_RX:
ANA_COMP:
reti
; ====================================================
Start:

;PortX  ,   .
;PinX   
;DDRX    ,     ,  -  .

; , DDRX ,  ,       PinX,  -  PortX:

;0 - 
;1 - 

ldi		temp,RamEnd
out		SPL,temp ;  

ser temp;     temp   1
out DDRB,temp;     
out DDRD,temp;  B   D  
clr temp;   temp (    temp  0)
out PortB,temp;    
out PortD,temp;  B  D 
clr	temp
sts	flags,temp

ldi temp,0b01000000
out Timsk,temp ;  
			;   101
ldi temp,0b00000101
out Tccr1b,temp ;  /64

ldi temp,0xF4
out Ocr1ah,temp
ldi temp,0x24
out Ocr1al,temp ;   62500 (0.4.  10)

sei ;   

	clr	temp
	sts	Adress1,temp
;********   ****************************
;   ,  LM016
; 4 bits interfase
;********   30  + FUNCTION SET************

; Function set
	rcall	delay3		; >30 ms
	ldi		Tx_b,0b00110000 ;
	rcall	in_port
	cbi		Portb,RS		; instruction
	rcall	zapis		;(1)
	
	rcall	zapis		;(2)
	
	rcall	zapis		;(3)
		
	ldi		Tx_b,0b00100000	
	rcall	in_port
	rcall	zapis
	
; Function set
	ldi		Tx_b,0b00101000	
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   
; Display clear
	ldi		Tx_b,0b00001101
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   
	ldi		Tx_b,0b00000001	
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	rcall	delay2

	ldi		Tx_b,0b00000110	
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   
;   
;     
; 0x20 - 0xFF


	ldi		temp,0x20
	sts		Adress,temp		;   DDRAM
_one_:

clr	temp
sts	flags,temp
	
;Set_DDRAM_ADDRESS

	rcall	BIN_BCD

	cbi		Portb,RS
	ldi		Tx_b,131             ; db7=1, address=03h
    rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   
;   
	
	sbi		Portb,RS			; RS=1
	lds		Tx_b,BCD_DT        ;   
	rcall	in_port
	rcall   zapis
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	
	lds		Tx_b,BCD_T        ;  
	rcall	in_port
	rcall   zapis
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   

	lds		Tx_b,BCD_S        ;  
	rcall	in_port
	rcall   zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   

	lds		Tx_b,BCD_D        ;  
	rcall	in_port
	rcall   zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   

	lds		Tx_b,BCD_E        ;  
	rcall	in_port
	rcall   zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   

	ldi		Tx_b,0x1f	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   

	lds		Tx_b,Adress
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   
;    

	cbi		Portb,RS
	ldi		Tx_b,171             ; db7=1, address=43h
    rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	sbi		Portb,RS

	ldi		Tx_b,'S'	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	
	ldi		Tx_b,'i'	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	
	ldi		Tx_b,'m'	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	
	ldi		Tx_b,'b'	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	
	ldi		Tx_b,'o'	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	
	ldi		Tx_b,'l'	      ; 
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	in_port
	rcall	zapis
	   
	   		
;  ,      
;       
;    
	
s8:
	lds		temp,flags
	tst		temp
	breq	s8
	clr		temp
	sts		flags,temp
			
; Clear display
	cbi		Portb,RS
	ldi		Tx_b,0b00000001
	rcall	in_port
	rcall	zapis
	   
	swap	Tx_b
	rcall	zapis
	rcall	delay2
	sbi		Portb,RS

	lds		Tx_b,Adress
	inc		Tx_b
	sts		Adress,Tx_b
	
	tst		Tx_b
	brne	s9
	ldi		Tx_b,0x20
	sts		Adress,Tx_b
s9:
	rjmp	_one_
	
	
;  
zapis:     
	sbi		Portb,E		; E=1 - 
	ldi		temp,5	; 1  -   
s3:
	nop
	nop
	dec		temp
	tst		temp
	brne	s3
	cbi		Portb,E		; 1  -   
	rcall	delay1
	ret

;  >100 uS
delay1:
	ldi	temp,t1
s4:
	nop
	nop
	nop
	dec	temp 
	tst	temp
	brne	s4
	ret

;   2 (>4.1 ) 
delay2:
	ldi	temp,t2
	ldi	temp1,0xff
	clr	temp2
s1:
	nop
	nop
	nop
	add	temp2,temp1
	tst	temp2
	brne s1
	dec	temp
	tst	temp
	brne	s1
	nop
	ret
;********   3 (30 ) ********************************************************************
delay3:
	ldi	temp,t3
	ldi	temp1,0xff
	clr	temp2
s2:
	nop
	nop
	nop
	nop
	add	temp2,temp1
	tst	temp2
	brne s2
	nop
	nop
	nop
	nop
	dec	temp
	tst	temp
	brne	s2
	ret

;********       
in_port:
	cbi		Portb,DB7	;  ,   DB7
	sbrc	Tx_b,7		;   7 
	sbi		Portb,DB7	;   
;------------------------------------
	cbi		Portb,DB6	;  ,   DB6
	sbrc	Tx_b,6		;   6 
	sbi		Portb,DB6	;            
;------------------------------------
	cbi		Portb,DB5	;  ,   DB5
	sbrc	Tx_b,5		;   5 
	sbi		Portb,DB5	;                  
;------------------------------------
	cbi		Portb,DB4	;  ,   DB4
	sbrc	Tx_b,4		;   4 
	sbi		Portb,DB4	;                       
;------------------------------------
	ret

BIN_BCD:
			
	clr	temp3
	clr	temp4
	clr	temp5
	clr	temp6
	clr	temp7

	lds	temp1,Adress
	lds	temp2,Adress1

	ldi		temp,16	;      , 
						;      
						;  LSB/MSB (8*2=16).
 ;------------------------------------------------------------------------------- 
 ; :        
 ; ,     TEMP (.16),  . 
 ;------------------------------------------------------------------------------- 
 ;   . 
 ;-------------------------------------------------------------------------------          
Loop16:   
	clc
						;    2-  , 
	rol	temp1			;     LSB/MSB,
	rol	temp2			;      
	
	rol	temp7			;     ,
	rol	temp6			;    ( )
	rol	temp5			;      
	
	dec	temp			
	tst	temp
	brne	adjDEC		;   =0,     adjDEC 
						;    =0,    .
	 
 ;----------------------------------------------- 
 ;     LED1...3 ( 
 ; )     LED1...5.
 ;     |0 6|5 5|3 6|  
 ; temp5,6,7
 ;----------------------------------------------- 

	mov		temp3,temp5		;    LED3 
	andi	temp3,0x0f	;   

	mov		temp4,temp6
	swap	temp4
	andi	temp4,0x0f

	mov		temp5,temp6
	andi	temp5,0x0f	;  

	mov		temp6,temp7
	andi	temp6,0xf0
	swap	temp6		;  

	andi	temp7,0x0f
 ;---------------------------------------------- 
 ;  .     LED1...7  
 ; -     .   = 0. 
 ;---------------------------------------------- 
 ;     30h    ASCII
	ori		temp3,0x30
	ori		temp4,0x30
	ori		temp5,0x30
	ori		temp6,0x30
	ori		temp7,0x30
	sts		BCD_DT,temp3	; load number
	sts		BCD_T,temp4
	sts		BCD_S,temp5
	sts		BCD_D,temp6
	sts		BCD_E,temp7
	ret		          ;         
                     ; 8-  .  
 ;---------------------------------------------- 
 ;    FSR   LED1...3     
 ;     adjBCD. 
 ;     LED -    .                       
 ;--------------------------------------------- 
 adjDEC:
	nop
	sts		Tim,temp7	;  temp7   Tim
	rcall	adjBCD
	lds		temp7,Tim
	sts		Tim,temp6	;  temp7   r0
	rcall	adjBCD
	lds		temp6,Tim
	sts		Tim,temp5		;  temp7   r0
	rcall	adjBCD
	lds		temp5,Tim
	rjmp	Loop16
 ;------------------------------------ 
 ;       -: 
 ;   LED1...3   03h,30h    3-  7- . 
 ;------------------------------------ 
 adjBCD:
	ldi	temp4,0x03		;    LED1 (LED1...3)   03h, 
	lds	temp3,Tim
	add	temp4,temp3		;   TEMP. 
	sbrc	temp4,3		;   3-   TEMP. 
	sts	Tim,temp4		;    3 =1,    TEMP  

	ldi	temp4,0x30		;    LED. 
	lds	temp3,Tim
  	add	temp4,temp3		;   3 =0,    LED  
	sbrc	temp4,7		;   30h,     ,   
	sts	Tim,temp4			;   W,   TEMP. 
						;   7-   TEMP. 
	;   7 =1,    TEMP  
	;    LED. 
	;   7 =0,   W   
 	;      adjDEC. 
	ret

Timer1_comp1:

in	r30,SREG

ldi r31,0
out Tcnt1h,r31
out Tcnt1l,r31 ; 

;      
	ldi	r31,1
	sts	flags,r31
	
OUT SREG,r30
reti

.EXIT
